#!/usr/bin/python 
import os
import sys
if os.path.isdir(os.path.abspath('lib')):
  sys.path.append('./lib')
else:
  sys.path.append('../lib')
import unicodedata
from silme.fp.manager import *
from silme.fp.object.dtd import *
from silme.fp.object.properties import *
from silme.fp.diff.text import *
from silme.io.file import *

def do(l10nEntityListReference, l10nEntityListLocale, l10nObjectReference, l10nObjectLocale):
  l10nDiffObject = l10nObjectLocale.diff(l10nObjectReference)
  if not isinstance(l10nDiffObject, ObjectDiff):
    l10nObjectDiffEntities = l10nDiffObject.getEntities()
    l10nDiffEntityList = l10nEntityListLocale.diff(l10nEntityListReference)
    l10nEntityListDiffEntities = l10nDiffEntityList.getEntities()
    collect = []
    for key, item in l10nEntityListDiffEntities.items():
      if key not in l10nObjectDiffEntities.keys(): # sprawdza czy czegos brakuje w l10nobjectdiff.getEntities(), choc powinno byc
        collect.append('missing in L10nObjectDiff.getEntities(): ' + key)
      else:
        if isinstance(item, EntityDiff) and isinstance(l10nObjectDiffEntities[key], Entity): # sprawdza czy w obydwu paczkach sa te same typy danych
            collect.append('exists, but different filetypes (EntityDiff vs Entity): ' + key)
        elif isinstance(item, Entity) and isinstance(l10nObjectDiffEntities[key], EntityDiff): # sprawdza czy w obydwu paczkach sa te same typy danych
            collect.append('exists, but different filetypes (Entity vs EntityDiff): ' + key)
        elif isinstance(item, EntityDiff) and isinstance(l10nObjectDiffEntities[key], EntityDiff): # jezeli w obydwu jest EntityDiff, ignoruj bo to prawidlowo
          pass
        elif (item.params['diff_flags'] != l10nObjectDiffEntities[key].params['diff_flags']): # element ma rozne flagi w zaleznosci
          collect.append('exists, but has different flags: ' + key)
    for key in l10nObjectDiffEntities.keys():
      if key not in l10nEntityListDiffEntities.keys(): # sprawdza czy czegos jest za duzo w l10nobjectdiff.getEntities()
        collect.append('too much in L10nObjectDiff.getEntities(): ' + key)
    if len(collect) > 0:
      print l10nEntityListLocale.uri + '\n' + '\n'.join(collect) +'\n\n'

rcsClient = IOManager.get('file')

files = [('en-US/messenger.dtd', 'pl/messenger.dtd'),
           ('en-US/msgHdrViewPopup.dtd', 'pl/msgHdrViewPopup.dtd'),
           ('en-US/messengercompose.dtd', 'pl/messengercompose.dtd'),
           ('en-US/prefs.properties', 'pl/prefs.properties'),
           ('en-US/abCardOverlay.dtd', 'pl/abCardOverlay.dtd'),
           ('en-US/contentAreaCommands.properties', 'pl/contentAreaCommands.properties'),
           ('en-US/bookmarks.dtd', 'pl/bookmarks.dtd'),
           ('en-US/editor.properties', 'pl/editor.properties'),
           ('en-US/baseMenuOverlay.dtd', 'pl/baseMenuOverlay.dtd'),
           ('en-US/messenger.properties', 'pl/messenger.properties')]

for element in files:
  L10nObjectReference = rcsClient.getL10nObject(element[0])
  L10nObjectLocale = rcsClient.getL10nObject(element[1])
  
  EntityListReference = rcsClient.getEntityList(element[0])
  EntityListLocale = rcsClient.getEntityList(element[1])
  
  do(EntityListReference, EntityListLocale, L10nObjectReference, L10nObjectLocale)
  